\setlength{\parindent}{0em}
\setlength{\parskip}{1ex plus 0.25ex minus 0.15ex}

% Use \dash for endash and \Dash for emdash
\usepackage{dash}

% This is for putting figures inside a paragraph
% Example: \begin{wrapfigure}{r}{0.25\textwidth}\includegraphics[width=0.2\textwidth]{xxx.png}\end{wrapfigure}
\usepackage{wrapfig} \setlength{\rightskip}{0pt plus 200pt} % see http://newsgroup.derkeiler.com/Archive/Comp/comt.text.tex/2010-10/msg00471.html

% asparadesc  A description environment
\definecolor{labelcolor}{rgb}{.318, .277, .718}  % #5147B7
\definecolor{labelnumcolor}{rgb}{.773, .769, .812}  % #C5C4CF
\usepackage[olditem,oldenum]{paralist}
\renewcommand*\paradescriptionlabel[1]{%
\normalfont\bfseries\color{labelcolor} #1}


% Bug in beamer; see 
%  http://tex.stackexchange.com/questions/50465/ref-with-beamer
% {\def\protect{\global\let\YesIMeanThisRef}\ref}
% \AtBeginDocument{\def\ref{\protect\YesIMeanThisRef}}
% \usepackage{xparse}% http://ctan.org/pkg/xparse

% \makeatletter
% \NewDocumentCommand{\reff}{s m}{%
%   \IfBooleanTF{#1}% Check for starred variant
%     {\beamer@origref{#2}}% \reff*
%     {\hyperlink{#2}{\beamer@origref{#2}}}% \reff
% }
% \makeatother

\usepackage{xparse}% http://ctan.org/pkg/xparse
% \NewDocumentCommand{\reff}{s m}{%
%   \IfBooleanTF{#1}% Check for starred variant
%     {\beamer@origref{#2}}% \reff*
%     {\hyperlink{#2}{\beamer@origref{#2}}}% \reff
% }
\NewDocumentCommand{\reff}{s m}{%
  \beamer@origref{#2}
  % \IfBooleanTF{#1}% Check for starred variant
  %   {\beamer@origref{#2}}% \reff*
  %   {\hyperlink{#2}{\beamer@origref{#2}}}% \reff
}
\AtBeginDocument{\makeatletter
\let\ref\reff  % make all references like \ref*{..}
\makeatother}

% {\def\protect{\global\let\YesIMeanThisRef}\ref}
% \AtBeginDocument{\def\ref{\protect\YesIMeanThisRef}}

% Make \section{..} show a page all alone.
\AtBeginSection{
\begin{frame}
\vfill
\begin{center}
\structure{\LARGE \insertsection}
\end{center}
\vspace*{14ex}
\end{frame}
}


% This must come before listings: https://github.com/gpoore/pythontex/issues/61
\usepackage[makestderr]{pythontex}
\setpythontexfv{fontsize=\footnotesize,
                fontfamily=zi4}  % inconsolata

% Make verbatim quotes correct
\usepackage{upquote}  

\usepackage{listings}
\lstset{ 
%   backgroundcolor=\color{white},   % choose the background color; you must add \usepackage{color} or \usepackage{xcolor}; should come as last argument
  basicstyle=\footnotesize\ttfamily,        % the size of the fonts that are used for the code
  breakatwhitespace=false,         % sets if automatic breaks should only happen at whitespace
  breaklines=false,                 % sets automatic line breaking
  captionpos=b,                    % sets the caption-position to bottom
%   commentstyle=\color{mygreen},    % comment style
  columns=flexible,              % banish insane letter spacing.
%   deletekeywords={...},            % if you want to delete keywords from the given language
%  escapeinside={\%*}{*)},          % if you want to add LaTeX within your code
%   extendedchars=true,              % lets you use non-ASCII characters; for 8-bits encodings only, does not work with UTF-8
%   frame=single,	                   % adds a frame around the code
keepspaces=true,                 % keeps spaces in text, useful for keeping indentation of code (possibly needs columns=flexible)
%   keywordstyle=\color{blue},       % keyword style
%   language=Octave,                 % the language of the code
%   morekeywords={*,...},            % if you want to add more keywords to the set
%   numbers=left,                    % where to put the line-numbers; possible values are (none, left, right)
%   numbersep=5pt,                   % how far the line-numbers are from the code
%   numberstyle=\tiny\color{mygray}, % the style that is used for the line-numbers
%   rulecolor=\color{black},         % if not set, the frame-color may be changed on line-breaks within not-black text (e.g. comments (green here))
  showspaces=false,                % show spaces everywhere adding particular underscores; it overrides 'showstringspaces'
  showstringspaces=false,          % underline spaces within strings only
  showtabs=false,                  % show tabs within strings adding particular underscores
%   stepnumber=2,                    % the step between two line-numbers. If it's 1, each line will be numbered
%   stringstyle=\color{mymauve},     % string literal style
%   tabsize=2,	                   % sets default tabsize to 2 spaces
%   title=\lstname                   % show the filename of files included with \lstinputlisting; also try caption instead of title
}
\lstset{basicstyle=\footnotesize,commentstyle=\color{blue},
        backgroundcolor=\color[HTML]{FBF5BB}}


% \usepackage{hyperref}

\usepackage{mathtools,amsthm,amssymb}

\renewcommand{\proofname}{\textsc{Pf}}
\renewcommand\qedsymbol{\rule{0.3em}{1.5ex}}

\newtheoremstyle{whitestyle}
{4pt plus 0.5pt minus 0.25pt}               %space above
{4pt plus 0.5pt minus 0.25pt}               %space below
{}                      %bodyfont
{0pt}                   %indent
{\scshape}              %headfont
{}                      %punctuation
{0.4em plus 0.2em}      %space after head
{\textcolor{blue}{\thmname{#1}} }       %theoremheadspec
% {\llap{\thmnumber{#2}\hspace*{2pt}}\thmname{#1} \thmnote{(#3)}}       %theoremheadspec
\theoremstyle{whitestyle}
\newtheorem{theorem}{Theorem}[section]
\newtheorem{lemma}[theorem]{Lemma}
\newtheorem{definition}[theorem]{Definition}
\newtheorem{corollary}[theorem]{Corollary}
\newtheorem{example}[theorem]{Example}
\newtheorem{remark}[theorem]{Remark}

% \usepackage{amsthm}
% \usepackage{thmtools}
% \declaretheoremstyle[
%   % spaceabove=6pt, spacebelow=6pt,
%   headfont=\normalfont\bfseries,
%   notefont=\mdseries, notebraces={(}{)},
%   bodyfont=\normalfont,
%   postheadspace=1em,
%   qed=\qedsymbol
%   ]{jhstyle}
% % \let\theorem\relax
% \declaretheorem[name=Theorem,
%   numbered=no, 
%   % style=jhstyle,
%   refname={Theorem,Theorems},
%   Refname={Theorem,Theorems}]{thm}
% % \let\definition\relax
% \declaretheorem[name=Definition,
%   numbered=no,
%   % style=jhstyle,
%   refname={Definition,Definitions},
%   Refname={Definition,Definitions}]{dfn}
% % \let\lemma\relax
% \declaretheorem[name=Lemma,
%   numbered=no,
%   %style=jhstyle,
%   refname={Lemma,Lemmas},
%   Refname={Lemma,Lemmas}]{lem}
% % \let\corollary\relax
% \declaretheorem[name=Corollary,
%   numbered=no,
%   %style=jhstyle,
%   refname={Corollary,Collaries},
%   Refname={Corollary,Collaries}]{cor}
% \declaretheorem[name=Example,
%   numbered=no,
%   %style=jhstyle,
%   refname={Example,Examples},
%   Refname={Example,Examples}]{exm}


% Vertically center graphics
% ex: \vcenteredhbox{\usegraphics{mygraph.png}}
% From http://tex.stackexchange.com/questions/7219/how-to-vertically-center-two-images
% \newcommand*{\vcenteredhbox}[1]{\begingroup
% \setbox0=\hbox{#1}\parbox{\wd0}{\box0}\endgroup}
